<template>
	<div>
		<canvas id="drawingCanvas" width="800" height="500"></canvas>
	</div>
</template>

<script>
export default {
	props: ['brushColor', 'brushSize'],
	data () {
		return {
			drawingSegments: [],
			segmentPoints: [],
			canvas: {},
			ctx: {},
			mouse: { x: 0, y: 0 },
			brush: {
				lineWidth: 2,
				lineJoin: 'round',
				lineCap: 'round',
				strokeStyle: '#2196f3'
			},
			isFirstStroke: true
		}
	},

	watch: {
		brushColor: function (newColor) {
			this.ctx.strokeStyle = newColor
		},
		brushSize: function (newSize) {
			this.ctx.lineWidth = newSize
		}
	},

	mounted () {
		this.canvas = this.$el.querySelector('#drawingCanvas')
		this.ctx = this.canvas.getContext('2d')
		this.canvas.addEventListener('mousemove', this.setMousePosition)
		
		this.setCanvasDefaults()

		this.canvas.addEventListener('mousedown', (e) => {
			this.ctx.beginPath()
			this.ctx.moveTo(this.mouse.x, this.mouse.y)
			this.canvas.addEventListener('mousemove', this.onDraw)
			this.setStartTime()
		})
		
		this.canvas.addEventListener('mouseup', () => {
			this.canvas.removeEventListener('mousemove', this.onDraw)
		
			this.drawingSegments.push(this.segmentPoints) // Save current segment points
			this.segmentPoints = []
			this.$emit('onDrawBreak', { segments: this.drawingSegments, dataUrl: this.canvas.toDataURL() }) // Save current status of the drawing
		})
	},

	methods: {
		setStartTime () {
			if (this.isFirstStroke) {
				this.$emit('setStartTime')
				this.isFirstStroke = false
			}
		},
		setMousePosition (e) {
			const canvasOffset = this.$el.querySelector('#drawingCanvas').getBoundingClientRect()
			this.mouse.x = e.pageX - canvasOffset.left
			this.mouse.y = e.pageY - canvasOffset.top
		},
		onDraw () {
			this.ctx.lineTo(this.mouse.x, this.mouse.y)
			this.ctx.stroke()
			this.segmentPoints.push({ 
				x: this.mouse.x, 
				y: this.mouse.y,
				brushColor: this.ctx.strokeStyle,
				brushSize: this.ctx.lineWidth
			})
		},
		setCanvasDefaults () {
			this.ctx.lineWidth = this.brush.lineWidth
			this.ctx.lineJoin = this.brush.lineJoin
			this.ctx.lineCap = this.brush.lineCap
			this.ctx.strokeStyle = this.brush.strokeStyle

			// Set white background
			this.ctx.fillStyle = '#fff'
			this.ctx.fillRect(0, 0, this.canvas.width, this.canvas.height)
		}
	}
}
</script>

<style scoped>
canvas {
	cursor: crosshair;
	box-shadow: 10px 10px 41px 1px rgba(199,199,199,1);
}
</style>
